﻿#language: ru

@ignore
@exportscenarios

Функционал: Общие сценарии

Сценарий: Я буду читать файл "ИмяФайла"

	И Я запоминаю значение выражения 'ОбщегоНазначенияКлиентСервер.РазложитьПолноеИмяФайла( Ванесса.ПолучитьСостояниеVanessaAutomation().ТекущаяФича.ПолныйПуть ).Путь + "\"' в переменную "КаталогТеста"
	И я буду выбирать внешний файл "$КаталогТеста$""ИмяФайла"

Сценарий: Я удаляю файл "пИмяФайла" если он существует

	И я запоминаю строку "пИмяФайла" в переменную "ИмяФайла"
	И Я запоминаю значение выражения 'ОбщегоНазначенияКлиентСервер.РазложитьПолноеИмяФайла( Ванесса.ПолучитьСостояниеVanessaAutomation().ТекущаяФича.ПолныйПуть ).Путь + "\$ИмяФайла$"' в переменную "ПолныйПутьКФайлу"
	Если Файл "$ПолныйПутьКФайлу$" существует
		Тогда я удаляю файл "$ПолныйПутьКФайлу$"

Сценарий: Я загружаю общую НСИ

	# При запуске тестов оптом могут остаться элементы от старых объектов и ломать логику
	* Удаление старых данных
		Дано я удаляю объекты "Справочники.Валюты" без контроля ссылок
		Дано я удаляю объекты "Справочники.Организации" без контроля ссылок
		Дано я удаляю объекты "Справочники.ВидыНоменклатуры" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2ТоварныеКатегории" без контроля ссылок
		Дано я удаляю объекты "Справочники.Номенклатура" без контроля ссылок
		Дано я удаляю объекты "Справочники.ХарактеристикиНоменклатуры" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2НаборыУпаковок" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2Бренды" без контроля ссылок
		Дано я удаляю объекты "Справочники.УпаковкиЕдиницыИзмерения" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2СезонныеГруппы" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2Производители" без контроля ссылок
		Дано я удаляю объекты "Справочники.Склады" без контроля ссылок
		Дано я удаляю объекты "Справочники.Подразделения" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2Волны" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2ВидыРабочихЦентров" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2РабочиеЦентры" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2РесурсныеСпецификации" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2ЭтапыПроизводства" без контроля ссылок
		Дано я удаляю объекты "Справочники.Контрагенты" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2ТочкиДоставки" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2СоглашенияСКлиентами" без контроля ссылок
		Дано я удаляю объекты "Справочники.ВидыЦен" без контроля ссылок
		Дано я удаляю объекты "Справочники.к2БизнесРегионы" без контроля ссылок
	Когда В командном интерфейсе я выбираю 'Администрирование' 'Загрузка из джсон'
	Тогда я жду открытия окна 'Загрузка из джсон' в течение 20 секунд
	И я устанавливаю флаг 'Перезаписывать'
	И Я запоминаю значение выражения 'ОбщегоНазначенияКлиентСервер.РазложитьПолноеИмяФайла( Ванесса.ПолучитьСостояниеVanessaAutomation().ТекущаяФича.ПолныйПуть ).Путь + "\"' в переменную "КаталогТеста"
	И я буду выбирать внешний файл "$КаталогТеста$""data.json"
	И я нажимаю кнопку выбора у поля "Файл с данными"
	И я нажимаю на кнопку 'Загрузить данные'
	И Я закрываю окно 'Загрузка из джсон'

Сценарий: Я загружаю НСИ из "ИмяФайла"

	Когда В командном интерфейсе я выбираю 'Администрирование' 'Загрузка из джсон'
	Тогда я жду открытия окна 'Загрузка из джсон' в течение 20 секунд
	И Я запоминаю значение выражения 'ОбщегоНазначенияКлиентСервер.РазложитьПолноеИмяФайла( Ванесса.ПолучитьСостояниеVanessaAutomation().ТекущаяФича.ПолныйПуть ).Путь + "\"' в переменную "КаталогТеста"
	И я буду выбирать внешний файл "$КаталогТеста$""ИмяФайла"
	И я нажимаю кнопку выбора у поля "Файл с данными"
	И я нажимаю на кнопку 'Загрузить данные'
	И Я закрываю окно 'Загрузка из джсон'
	
Сценарий: Я устанавливаю время начала блока тестов

	И Я запоминаю значение выражения 'Строка(ТекущаяДата())' в переменную "НачалоБлокаТестов" глобально

Сценарий: В журнале регистрации "КоличествоОшибок" ошибок по текущему блоку

	Дано Я подключаюсь под "Администратор"
	И В журнале регистрации "КоличествоОшибок" ошибок начиная с "$$НачалоБлокаТестов$$"

Сценарий: Я удаляю старый элемент "Имя элемента"

	Если в таблице "Список" есть строка Тогда
		| 'Наименование' |
		| 'Имя элемента' |
		И в таблице "Список" я перехожу к строке:
		| 'Наименование' |
		| 'Имя элемента' |
		И в таблице "Список" я выбираю текущую строку
		Тогда я жду открытия окна "Имя элемента"" (*)" в течение 20 секунд
		И в поле 'Наименование' я ввожу текст 'Удалено'
		И я нажимаю на кнопку 'Пометить на удаление / Снять пометку'
		Тогда я жду открытия окна '1С:Предприятие' в течение 20 секунд
		И я нажимаю на кнопку 'Да'
		Тогда я жду открытия окна 'Удалено (*)' в течение 20 секунд
		И Я закрываю окно 'Удалено (*)'

Сценарий: Я удаляю старую номенклатуру "Имя элемента"
	
	Если в таблице "Список" есть строка Тогда
		| 'Наименование' |
		| 'Имя элемента' |
		И в таблице "Список" я перехожу к строке:
		| 'Наименование' |
		| 'Имя элемента' |
		И в таблице "Список" я выбираю текущую строку
		Тогда я жду открытия окна "Имя элемента"" (*)" в течение 20 секунд
		И в поле 'Рабочее наименование' я ввожу текущую дату и текущее время
		И я нажимаю на кнопку 'Пометить на удаление / Снять пометку'
		Тогда я жду открытия окна '1С:Предприятие' в течение 20 секунд
		И я нажимаю на кнопку 'Да'
		Тогда я жду открытия окна '* (*)' в течение 20 секунд
		И Я закрываю окно '* (*)'

# Панель отборов

Сценарий: Я разворачиваю панель отборов

	Если поле с именем 'СвернутьРазвернутьБоковуюПанельОтбора' имеет заголовок '<<' тогда
		И я нажимаю на гиперссылку '<<'

Сценарий: Я сворачиваю панель отборов

	Если поле с именем 'СвернутьРазвернутьБоковуюПанельОтбора' имеет заголовок '>>' тогда
		И я нажимаю на гиперссылку '>>'

Сценарий: Я открываю журнал регистрации и нахожу "КоличествоОшибок" общих ошибок и "КоличествоОшибокПроведений" ошибок проведений документов по текущему блоку

	И В командном интерфейсе я выбираю 'Администрирование' 'Обслуживание'
	Тогда открылось окно 'Обслуживание'
	И я нажимаю на кнопку 'Журнал регистрации'
	Тогда открылось окно 'Журнал регистрации'
	И Ожидаем завершения фонового формирования отчета в течение "10" секунд
	И я перехожу к закладке "Журнал регистрации"
	И из выпадающего списка "Критичность" я выбираю точное значение 'Ошибка'
	И я нажимаю на гиперссылку "Отбор"
	Тогда открылось окно 'Отбор журнала регистрации'
	И в поле 'Интервал с' я ввожу текст '$$НачалоБлокаТестов$$'
	И я нажимаю на кнопку 'Применить и закрыть'
	И я перехожу к закладке "Индикатор длительных операций"
	И Ожидаем завершения фонового формирования отчета в течение "10" секунд
	И я перехожу к закладке "Журнал регистрации"
	И я жду, что в таблице "Журнал" количество строк будет "равно" "КоличествоОшибок" в течение 3 секунд
	И я нажимаю на гиперссылку с именем "ПредставлениеОтбора"
	Тогда открылось окно 'Отбор журнала регистрации'
	И я нажимаю кнопку выбора у поля с именем "События"
	Тогда открылось окно 'Выбор значений для отбора'
	И в таблице "Список" я нажимаю на кнопку с именем 'СнятьВсе'
	Если в таблице "Список" есть строка Тогда
		| 'Представление'        | 
		| 'Проведение документа' |
		И в таблице "Список" я перехожу к строке:
			| 'Представление'        | 
			| 'Проведение документа' |
		И в таблице "Список" я устанавливаю флаг с именем 'Пометка'
		И в таблице "Список" я завершаю редактирование строки
		И я нажимаю на кнопку с именем 'OK'
		Тогда открылось окно 'Отбор журнала регистрации'
		И я нажимаю на кнопку с именем 'УстановитьФлажки'
		И я нажимаю на кнопку 'Применить и закрыть'
		И я перехожу к закладке "Индикатор длительных операций"
		И Ожидаем завершения фонового формирования отчета в течение "10" секунд
		И я перехожу к закладке "Журнал регистрации"
		И я жду, что в таблице "Журнал" количество строк будет "равно" "КоличествоОшибокПроведений" в течение 3 секунд
	И Я закрыл все окна клиентского приложения

#Работа с датами и периодами
Сценарий: Я указываю в диалоге стандартного периода период с "ДатаНачала" по "ДатаОкончания"
	
	Тогда открылось окно 'Выберите период'
	И в поле 'DateBegin' я ввожу текст "ДатаНачала"
	И в поле 'DateEnd' я ввожу текст "ДатаОкончания"
	И я нажимаю на кнопку 'Выбрать'

Сценарий: Я указываю в диалоге стандартного периода текущую дату
	
	Тогда открылось окно 'Выберите период'
	И в поле 'DateBegin' я ввожу текущую дату
	И в поле 'DateEnd' я ввожу текущую дату
	И я нажимаю на кнопку 'Выбрать'

Сценарий: Я очищаю период в диалоге стандартного периода

	Тогда открылось окно 'Выберите период'
	И я нажимаю на кнопку 'Очистить период'
	И я нажимаю на кнопку 'Выбрать'